#########################################################
#
#
#  alienizer.py   - A galaxy invaders clone
#
#  
#
#   22th September 2008
#
#   rsbrooks@gmail.com
#
#
#
#
#########################################################

#
#
#  Instructions:
#  arrow keys to stear the ship
#  z key to fire the missiles
#  3 lives and your out !
#
#
#



######### IMPORTS ###################################################
import random, math, pygame
from pygame.locals import *
import copy ### needed to create copies of lists
import time ### needed to seed random numbers
random.seed(int(time.time()))

            

def main():


    ###### CONSTANTS
    WINSIZE = [300,675]  # 4 x axis, 9 y axis 75 x 75 pixel tiles
    WHITE = [255,255,255]
    BLACK = [0,0,0]
    BLOCKSIZE = [75,75]
    SHIPTRACK = [[0,525],[75,525],[150,525]]   
    #### tick constants control how fast these items move - larger values slower
    MISSILETICK = 20
    ALIENTICK = 60 ## was 80
    BOMBTICK = 40
    EXPLOSIONTICK = 40
    
    ###### VARIABLES

    gameover = 0
    missilehit = 0
    missilefired = 0
    missileinflight = 0
    missileposition = []
    missiletick = 0
    shippossition = 1 ### 0 = left, 1 = middle, 2 = right
    alienpositions = []
    explosion = []
    ticker = 0
    score = 0
    explosiontick = 0
    bombpositions = []
    bombfalling = 0
    bombhit = 0
    livestrack = [[0,600],[75,600],[150,600]]
    
    #####  initialise pygame and load assets

    pygame.mixer.pre_init(44000, 16, 2, 4096)
    pygame.init()
    clock = pygame.time.Clock()
    screen = pygame.display.set_mode(WINSIZE)
    pygame.display.set_caption('Alienizer')
    screen.fill(BLACK)
    ship = pygame.image.load('ship.bmp').convert()
    alien = pygame.image.load('alien2.bmp').convert()
    bomb = pygame.image.load('bomb.bmp').convert()
    missile = pygame.image.load('missile.bmp').convert()
    lives = pygame.image.load('lives.bmp').convert()
    blast = pygame.image.load('blast.bmp').convert()

    missilesound = pygame.mixer.Sound('missile.ogg')
    explosionsound = pygame.mixer.Sound('explosion.ogg')
    die1sound = pygame.mixer.Sound('die1.ogg')
    die2sound = pygame.mixer.Sound('die2.ogg')
    die3sound = pygame.mixer.Sound('die3.ogg')
    
    font = pygame.font.SysFont("arial", 48)

    ###### main game loop
        
    while not gameover:
        
        ####### timer   ( missile timer and explosion timer are local )

        ticker += 1
        
        ################# clear the screen ready for everything to be re-drawn    
        screen.fill(BLACK)

        ################## Get user input and set ship position variable
        
        for event in pygame.event.get():
            if event.type == QUIT:
                exit()
                
        pressed_keys = pygame.key.get_pressed()
        
        if pressed_keys[K_LEFT]:
            shipposition = 0
        elif pressed_keys[K_RIGHT]:
            shipposition = 2
        else:
            shipposition = 1

        if pressed_keys[K_z] and not missileinflight:
            missilesound.play()  ### play the missile sound file
            missilefired = 1
            
        ################# alien processing

        if len(alienpositions) > 0 and ticker % ALIENTICK == 0:
            ### we need to move some aliens randomly
            ### lets loop round all aliens in array and move them
            i = len(alienpositions) - 1
            while i >= 0:
                ## set up a random range of values so we can decide which way to move
                movement = random.randrange(1,10)
                if movement > 4:  ## down  - most likely due to weighting
                    ## make sure we dont go off screen or hit another alien
                    if alienpositions[i][1] + 75 <= 525 and alienpositions.count((alienpositions[i][0],alienpositions[i][1]+75)) == 0:
                        alienpositions[i][1] += 75
                    else:
                        ### we are at the ship level so game is over
                        gameover = 1
                elif movement <= 2:  ## left
                    ## make sure we dont go off screen or hit another alien or move towards missile
                    if alienpositions[i][0] - 75 > 0 and alienpositions.count([alienpositions[i][0]-75,alienpositions[i][1]]) == 0:
                        if len(missileposition) == 0:
                            alienpositions[i][0] -= 75
                        else:
                            if alienpositions[i][0] - 75 != missileposition[0]:
                               alienpositions[i][0] -= 75 
                elif movement <= 4:  ## right
                    ## make sure we dont go off screen or hit another alien or move towards missile
                    if alienpositions[i][0] + 75 < 225 and alienpositions.count([alienpositions[i][0]+75,alienpositions[i][1]]) == 0:
                        if len(missileposition) == 0:
                            alienpositions[i][0] += 75
                        else:
                            if alienpositions[i][0] + 75 != missileposition[0]:
                               alienpositions[i][0] += 75
        
                i -= 1
                
        if len(alienpositions) < 3 and ticker % ALIENTICK == 0:
            ### we need some more aliens on the screen as there are less than 3
            flag = 0  
            while flag == 0:
                temprand = random.randrange(0,3)
                ### lets make sure we down spawn on top of an alien
                if alienpositions.count([temprand*75,75]) == 0:
                    alienpositions.append([temprand*75,75])
                    flag = 1

        ###################### bombs processing
        
        if len(bombpositions) == 0 and ticker % BOMBTICK == 0 and len(alienpositions) > 0:
            ###### lets generate some bombs as there aren't any on screen

            if random.randrange(1,10) > 7:  ## add some random element to bomb dropping
                #### pick an alien ( some time make this the lowest alien )
                bombpositions.append(copy.deepcopy(alienpositions[random.randrange(0,len(alienpositions))-1])) ## had to use copy here
                bombfalling = 1
        if bombfalling == 1 and ticker % BOMBTICK == 0:
            ###### loop though all the bombs and make them fall one step
            i = len(bombpositions) - 1
            while i >= 0:
                bombpositions[i][1] += 75
                if bombpositions[i][1] > 525:
                    ### if we have hit the bottom delete the bomb
                    bombpositions.pop(i)
                elif bombpositions[i] == SHIPTRACK[shipposition]:
                    ### bomb has hit the ship
                    bombpositions.pop(i)
                    explosion.append(SHIPTRACK[shipposition])  ## record where to draw blast
                    explosiontick += EXPLOSIONTICK  ## increment tick count so explosion is displayed longer
                    livestrack.pop()
                    if (len(livestrack)) == 2:
                        die1sound.play()
                    elif (len(livestrack)) == 1:
                        die2sound.play()
                    ### if this was the last life them set the gameover flag
                    if len(livestrack) == 0:
                        gameover = 1
                i -= 1
                
                
                

        ################# Missile processing

        if missilefired == 1 or missileinflight == 1:
            ### lets test to see if we have hit and alien
            if alienpositions.count(missileposition) > 0:
                explosionsound.play()
                alienpositions.remove(missileposition)  ## remove the alien
                explosion.append(missileposition)  ## record where to draw blast
                missileinflight = 0  ## reset missile values
                missilefired = 0     ## reset missile values
                missileposition = [] ## reset missile values
                explosiontick += EXPLOSIONTICK  ## increment tick count for each alien destroyed
                score += 1
            ### lets see if we have hit a bomb
            elif bombpositions.count(missileposition) > 0:
                explosionsound.play()
                bombpositions.pop(bombpositions.index(missileposition)) ## delete bomb
                explosion.append(missileposition)  ## make an explosion
                explosiontick += EXPLOSIONTICK
                missileinflight = 0  ## reset missile values
                missilefired = 0     ## reset missile values
                missileposition = []        

        if missileinflight == 1: 

            missiletick += 1
            if missiletick % MISSILETICK == 0:
                missileposition[1] -= 75
                if missileposition[1] < 75:
                    missileinflight = 0
                    missileposition =[]

        elif missilefired == 1:
            missileposition.append(SHIPTRACK[shipposition][0])
            missileposition.append(SHIPTRACK[shipposition][1])
            missileposition[1] -= 75
            missilefired = 0
            missileinflight = 1

        if missilefired == 1 or missileinflight == 1:
            screen.blit(missile,missileposition)

        
            

        ################## RENDER SCREEN

        ## draw ship

        screen.blit(ship,SHIPTRACK[shipposition])

        ## draw lives

        for elements in livestrack:
            screen.blit(lives,elements)


        ## draw bombs
        for i in bombpositions:
                screen.blit(bomb,i)

        ## draw aliens
        for i in alienpositions:
                screen.blit(alien,i)
                
        ## draw explosions
        if len(explosion) > 0:
            for i in explosion:
                screen.blit(blast,i)
            explosiontick -= 1
            ## are we at an explosiontick value indicating end of explosion display
            if explosiontick % EXPLOSIONTICK == 0 or explosiontick == 0:
                explosion.pop(0)  ## remove the oldest explosion hence the pop(0) !

        
        scoresurface = font.render(str(score), True, WHITE)
        screen.blit(scoresurface, (150,10))
            
        pygame.display.update()

      
        clock.tick(100)

    ###### end of game flashing display
    die3sound.play()
    ticker = 0
    while 1:

        for event in pygame.event.get():
            if event.type == QUIT:
                exit()
                
        if ticker < 75:

            ## draw ship

            screen.blit(ship,SHIPTRACK[shipposition])

            ## draw lives

            for elements in livestrack:
                screen.blit(lives,elements)


            ## draw bombs
            for i in bombpositions:
                    screen.blit(bomb,i)

            ## draw aliens
            for i in alienpositions:
                    screen.blit(alien,i)
                    
            ## draw explosions
            if len(explosion) > 0:
                for i in explosion:
                    screen.blit(blast,i)
                explosiontick -= 1
                ## are we at an explosiontick value indicating end of explosion display
                if explosiontick % EXPLOSIONTICK == 0 or explosiontick == 0:
                    explosion.pop(0)  ## remove the oldest explosion hence the pop(0) !

            
            scoresurface = font.render(str(score), True, WHITE)
            screen.blit(scoresurface, (130,10))
            ticker += 1
            
        elif ticker < 150:
            screen.fill(BLACK)
            ticker += 1
        else:
            ticker = 0
            
        pygame.display.update()
        clock.tick(100)
    

if __name__ == '__main__':
    main()
